package auth

import (
	"context"
	"im-auth/pb"
)

type ImAuthServer struct {
	pb.UnimplementedImAuthServiceServer
}

//验权
func (u *ImAuthServer) ImAuth(ctx context.Context, in *pb.AuthRequest) (reply *pb.AuthReply, err error) {
	reply = &pb.AuthReply{}
	// 请求超时
	if ctx.Err() == context.Canceled {
		reply.Code = 408
		reply.Msg = "请求超时"
		return
	}
	//获取用户信息
	c_user, _ := GetImUserByAccidAppkey(in.Accid, in.AppId)
	if c_user.Token == "" {
		reply.Code = 404
		reply.Msg = "用户不存在"
		return
	}

	//验证token
	if in.Token != c_user.Token {
		reply.Code = 302
		reply.Msg = "token已失效"
		return
	}
	//用户登录处理
	//res, msg := LoginHandle(in)

	reply.Code = 0
	reply.Msg = "ok"
	return
}
